package com.jiuqi.script.rhino;

package .tmp;

import java.lang.reflect.Method;
import java.util.Map;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.ScriptableObject;

public class LimitedScriptObject extends ScriptableObject {
  private static final long serialVersionUID = 8048574707866032033L;
  
  private static final Object[] emptyArray = new Object[0];
  
  private Object self;
  
  private Map methods;
  
  public LimitedScriptObject(Object obj, Map methods) {
    this.self = obj;
    this.methods = methods;
  }
  
  public String getClassName() {
    return "LimitedScriptObject";
  }
  
  public Object[] getAllIds() {
    return getIds();
  }
  
  public Object[] getIds() {
    return this.methods.keySet().toArray();
  }
  
  public Object get(String name, Scriptable start) {
    Method m = (Method)this.methods.get(name);
    if (m != null)
      return new Object(this, m); 
    String firstChar = name.substring(0, 1);
    firstChar = firstChar.toUpperCase();
    String getter = "get" + firstChar + name.substring(1);
    Method m1 = (Method)this.methods.get(getter);
    if (m1 == null)
      throw new IllegalArgumentException("Unknown method or property:" + name); 
    Object result = null;
    try {
      result = m1.invoke(this.self, emptyArray);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return result;
  }
  
  public boolean has(String name, Scriptable start) {
    return this.methods.containsKey(name);
  }
}
